package game

import (
	"sirlab.de/go/knyt/syncdata"
)

func (gm *Game) populateSyncDataCb(syncData *syncdata.SyncData) {
	syncData.GameInfo = gm.populateGameInfo()
}

func (gm *Game) populateGameInfo() syncdata.GameInfo {
	gm.mu.Lock()
	defer gm.mu.Unlock()

	players := make([]syncdata.PlayerInfo, 0)
	for _, p := range gm.players {
		if p.isPlaying {
			players = append(players, syncdata.PlayerInfo{
				Id:     p.id,
				Name:   p.name,
				IsIdle: p.isIdle,
			})
		}
	}

	return syncdata.GameInfo{
		GameId:  gm.id,
		State:   gm.state,
		Players: players,
	}
}
